/*
Copyright (c) 2004 bayside
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#if !defined(_CONTROL_H_INCLUDED_)
#define _CONTROL_H_INCLUDED_

class Container;

/**
 iNX
 */
class Control : public Object {
public:
	//
	// zu
	//
	/**  */
	static const int ALIGN_LEFT   = 1;
	/**  */
	static const int ALIGN_CENTER = 2;
	/** E */
	static const int ALIGN_RIGHT  = 3;

private:
	/** ei */
	Container *parent;
	/** E񊈐 */
	bool enabled;
	/** tH[JXL */
	bool focused;
	/** \E\ */
	bool visible;
	/** xi΍Wj */
	int x;
	/** yi΍Wj */
	int y;
	/**  */
	int height;
	/**  */
	int width;
	/** wiF */
	unsigned int backColor;
	/** OiF */
	unsigned int foreColor;
	/** tHgX^C */
	int fontStyle;
	/** ȋ傫 */
	Rect rect;
	/** `̈ */
	Graphics *_g;
	/** `obt@[ */
	Image *_buffer;
	/** tHg */
	FontMetrics *_metrics;

protected:
	/** tH[JXCxg */
	Event focusEvent;

public:
	/** RXgN^ */
	Control();
	
	/** fXgN^ */
	virtual ~Control();
	
	/**
	 inh.
	 onExit()ĂԂƍďłB
	 */
	virtual void onStart();
	
	/**
	 ijnh.
	 onStart()ĂԂƍďłB
	*/
	virtual void onExit();

	/** Cxgnh */
	virtual void onEvent(Event *event);
	
	/** `nh */
	virtual void onPaint(Graphics *g);
	
	/** Cxg */
	virtual void postEvent(Event *event);
	
	/**
	 ĕ`.
	 ̒onPaint()update()ĂԁB
	 */
	virtual void repaint();
	
	/** iXV */
	virtual void update();
	
	/** ei𓾂 */
	inline Container *getParent() { return this->parent; }
	
	/** E񊈐𓾂 */
	inline bool getEnabled() { return this->enabled; }
	
	/** tH[JXԂ𓾂 */
	inline bool getFocused() { return this->focused; }
	
	/** \E\𓾂 */
	inline bool getVisible() { return this->visible; }
	
	/** XW𓾂 */
	inline int getX() { return this->x; }
	
	/** YW𓾂 */
	inline int getY() { return this->y; }
	
	/** 𓾂 */
	inline int getWidth() { return this->width; }
	
	/** 𓾂 */
	inline int getHeight() { return this->height; }
	
	/** ȋ傫 */
	inline Rect *getRect() { return &this->rect; }
	
	/** wiF𓾂 */
	inline unsigned int getBackground() { return this->backColor; }
	
	/** OiF𓾂 */
	inline unsigned int getForeground() { return this->foreColor; }
	
	/** tHgX^C𓾂 */
	inline int getFontStyle() { return this->fontStyle; }
	
	/** `IuWFNg𓾂 */
	virtual Graphics *getGraphics() { return this->_g; }
	
	/**
	 obt@[𓾂.
	 VRAM̂悤ɒڕ`悵ƂɗpB
	 GraphicsNXĂ悤ȕ֗ȃ\bh͂ȂB
	 `update()ĂԂƂŎۂ̕`悪B
	 */
	virtual Image *getBuffer() { return this->_buffer; }
	
	/** tHg𓾂 */
	inline FontMetrics *getFontMetrics() { return this->_metrics; }
	
	/**
	 CEBhE𓾂.
	 CEBhEƂ͑SĂ̕iĂԉ̃EBhEB
	 CEBhE͊eAvP[VƂɕKP݂ĂB
	 */
	virtual Control *getMainWindow();
	
	/**
	 Ԃݒ肷
	 @param enabled  (true / false)
	 */
	virtual void setEnabled(bool enabled);
	
	/**
	 tH[JXԂݒ肷.
	 ̃\bhĂԂƊYiFOCUS_IN܂FOCUS_OUTCxgB
	 @param focused tH[JX (true / false)
	 */
	virtual void setFocused(bool focused);
	
	/**
	 \Ԃݒ肷
	 @param visible \ (true / false)
	 */
	virtual void setVisible(bool visible);
	
	/**
	 傫ݒ肷
	 @param x xW
	 @param y yW
	 @param width 
	 @param height 
	*/
	virtual void setRect(int x, int y, int width, int height);
	
	/**
	 ʒuύX
	 @param x XW
	 @param y YW
	*/
	virtual void setLocation(int x, int y);
	
	/**
	 eiݒ肷
	 @param parent ei
	*/
	virtual void setParent(Container *parent);
	
	/** wiFݒ肷 */
	virtual void setBackground(unsigned int backColor);
	
	/** OiFݒ肷 */
	virtual void setForeground(unsigned int foreColor);
	
	/**
	 tHgX^CiʏAAΎAŒ蕝jݒ肷.
	 eX^C"|"őgݍ킹邱Ƃ\B
	 @param style tHgX^C (Font::PLAIN / Font::BOLD / Font::ITALIC / Font::FIXED )
	*/
	virtual void setFontStyle(int style);
};

#endif // _CONTROL_H_INCLUDED_
