/*
Copyright (c) 2004 bayside
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#if !defined(_GRAPHICS_H_INCLUDED_)
#define _GRAPHICS_H_INCLUDED_

/**
 `NX
*/
class Graphics : public Object {
private:
	int tx, ty;
	int cx, cy, cw, ch;
	int width, height;
	/** Fi4oCgj */
	unsigned int rgb24;
	/** tHgX^C */
	int fontStyle;
	/** obt@[ */
	Image *image;

public:
	/** RXgN^ */
	Graphics();

	/**
	 RXgN^
	 @param image obt@[
	*/
	Graphics(Image *image);
	
	/** fXgN^ */
	virtual ~Graphics();
	
	/**
	 _`
	 @param x XW
	 @param y YW
	 @param color `悷F
	 */
	void drawPixel(int x, int y, unsigned int color);
	
	/**
	 C[W`
	 @param image C[W
	 @param x `JnXW
	 @param y `JnYW
	 */
	void drawImage(Image *image, int x, int y);
	
	/**
	 `
	 @param x0 n_X
	 @param y0 n_Y
	 @param x1 I_X
	 @param y1 I_Y
	 */
	void drawLine(int x0, int y0, int x1, int y1);
	
	/**
	 ``
	 @param x n_X
	 @param y n_Y
	 @param width 
	 @param height 
	 */
	void drawRect(int x, int y, int width, int height);
	
	/**
	 ~`
	 @param x0 SX
	 @param y0 SY
	 @param r  a
	 */
	void drawCircle(int x0, int y0, int r);
	
	/**
	 `
	 @param str isΉj
	 @param x n_X
	 @param y n_Y
	 */
	void drawText(char *str, int x, int y);
	
	/**
	 ~hԂ`
	 @param x0 SX
	 @param y0 SY
	 @param r  a
	 */
	void fillCircle(int x0, int y0, int r);
	
	/**
	 `ʂԂ`
	 @param x n_X
	 @param y n_Y
	 @param width 
	 @param height 
	 */
	void fillRect(int x, int y, int width, int height);
	
	/**
	 Wݒ
	 @param x n_X
	 @param y n_Y
	 */
	void translate(int x, int y);
	
	/** 𓾂 */
	inline int getWidth() { return this->width; }
	
	/** 𓾂 */
	inline int getHeight() { return this->height; }
	
	/** tHgX^C𓾂 */
	inline int getFontStyle() { return this->fontStyle; }
	
	/**
	 NbsÖݒ
	 @param cx n_X
	 @param cy n_Y
	 @param cw I_X
	 @param ch I_Y
	 */
	void setClip(int cx, int cy, int cw, int ch);
	
	/**
	 Fݒ
	 @param r (0-255)
	 @param g (0-255)
	 @param b (0-255)
	 */
	void setColor(unsigned char r, unsigned char g, unsigned char b);
	
	/**
	 Fݒ
	 @param color (0x0-0xFFFFFF)
	 */
	void setColor(unsigned int color);
	
	/**
	 tHgX^CiʏAAΎAŒ蕝jݒ肷.
	 eX^C"|"őgݍ킹邱Ƃ\B
	 @param style tHgX^C (Font::PLAIN / Font::BOLD / Font::ITALIC / Font::FIXED )
	*/
	void setFontStyle(int style);
};

#endif // _GRAPHICS_H_INCLUDED_
