/*
Copyright (c) 2004 bayside
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO MOUSEEVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#if !defined(_MOUSEEVENT_H_INCLUDED_)
#define _MOUSEEVENT_H_INCLUDED_

/**
 }EXCxgNX
*/
class MouseEvent : public Event {
private:
	/** XW */
	int x;
	/** YW */
	int y;
	/** {^ */
	unsigned int button;
	
public:
	/** ftHgRXgN^ */
	MouseEvent() {
		setType(MOUSE_PRESSED);
		setSource(NULL);
		this->x = this->y = 0;
		this->button = 0;
	}
	
	/**
	 RXgN^.
	 x, y ̓CEBhE̓̈̍ɑ΂鑊΍WłB
	 ΍W(ax,ay)͈ȉ̂悤Ɏ擾B
	 <ul>
	 <li> ax = x + getMainWindow()->getRect()->getX() + Window::INSETS_LEFT;
	 <li> ay = y + getMainWindow()->getRect()->getY() + Window::INSETS_TOP;
	 </ul>
	 @param type type Cxg^Cv
	 @param source Cxg
	 @param x XWi΍Wj
	 @param y YWi΍Wj
	*/
	MouseEvent(int type, Control *source, int x, int y)
	{
		setType(type);
		setSource(source);
		this->x = x;
		this->y = y;
	}
	
	/** fXgN^ */
	virtual ~MouseEvent() {}
	
	/** XW𓾂 */
	inline int getX() { return this->x; }
	
	/** XWݒ肷 */
	inline void setX(int x) { this->x = x; }
	
	/** YW𓾂 */
	inline int getY() { return this->y; }
	
	/** YWݒ肷 */
	inline void setY(int y) { this->y = y; }
	
	/** {^ʂ𓾂 */
	inline unsigned int getButton() { return this->button; }
	
	/** {^ʂݒ肷 */
	inline void setButton(unsigned int button) { this->button = button; }
};

#endif // _MOUSEEVENT_H_INCLUDED_
