/*
Copyright (c) 2004 bayside
All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions
are met:
1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.
2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.
3. The name of the author may not be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "baygui.h"

/** 未チェック（パレット） */
unsigned int unchecked_palette[] = {
	0xff040204,
	0xff8c8e8c,
	0xffe4e2e4,
	0xff4c4e4c,
	0xffb4b2b4,
	0xfffcfefc,
	0xffc0c0c0, // 背景色
	0xffeceeec,
	0xff5c5e5c,
	0xffc4c2c4,
};

/** 未チェック（データ）*/
unsigned char unchecked_data[] = {
	0x6,0x6,0x6,0x6,0x3,0x0,0x0,0x3,0x6,0x6,0x6,0x6,
	0x6,0x6,0x0,0x8,0x2,0x2,0x2,0x9,0x3,0x0,0x6,0x6,
	0x6,0x0,0x9,0x2,0x7,0x5,0x5,0x5,0x2,0x1,0x0,0x6,
	0x6,0x8,0x2,0x7,0x5,0x5,0x7,0x7,0x2,0x9,0x3,0x6,
	0x3,0x2,0x7,0x5,0x5,0x7,0x7,0x7,0x2,0x9,0x1,0x3,
	0x0,0x2,0x5,0x5,0x7,0x7,0x2,0x2,0x9,0x9,0x1,0x0,
	0x0,0x2,0x5,0x7,0x7,0x7,0x2,0x9,0x9,0x4,0x1,0x0,
	0x3,0x9,0x5,0x7,0x2,0x2,0x9,0x9,0x4,0x4,0x1,0x3,
	0x6,0x8,0x2,0x2,0x2,0x9,0x9,0x4,0x4,0x1,0x3,0x6,
	0x6,0x0,0x1,0x9,0x9,0x9,0x4,0x4,0x1,0x1,0x0,0x6,
	0x6,0x6,0x0,0x8,0x1,0x1,0x1,0x1,0x3,0x0,0x6,0x6,
	0x6,0x6,0x6,0x6,0x3,0x0,0x0,0x3,0x6,0x6,0x6,0x6,
};

/** チェック（パレット） */
unsigned int checked_palette[] = {
	0xff040204,
	0xff8c8e8c,
	0xff4c4e4c,
	0xffe4e2e4,
	0xffc0c0c0, // 背景色
	0xffc4c2c4,
	0xff7c7e7c,
	0xff2c2a2c,
	0xff9c9e9c,
	0xfffcfefc,
	0xff5c5e5c,
};

/** チェック（データ）*/
unsigned char checked_data[] = {
	0x4,0x4,0x4,0x4,0x7,0x0,0x0,0x7,0x4,0x4,0x4,0x4,
	0x4,0x4,0x7,0x0,0x2,0xa,0xa,0xa,0x2,0x0,0x4,0x4,
	0x4,0x7,0x2,0xa,0x6,0x6,0x6,0x1,0x1,0x8,0x0,0x4,
	0x4,0x0,0xa,0x6,0x0,0x0,0x0,0x0,0x8,0x8,0x2,0x4,
	0x7,0x2,0x6,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x5,0x2,
	0x0,0xa,0x6,0x0,0x0,0x0,0x0,0x0,0x0,0x5,0x5,0x0,
	0x0,0xa,0x6,0x0,0x0,0x0,0x0,0x0,0x0,0x5,0x3,0x0,
	0x7,0xa,0x1,0x0,0x0,0x0,0x0,0x0,0x0,0x3,0x9,0x2,
	0x4,0x7,0x1,0x8,0x0,0x0,0x0,0x0,0x3,0x9,0x2,0x4,
	0x4,0x7,0x8,0x8,0x8,0x5,0x5,0x3,0x9,0x9,0x0,0x4,
	0x4,0x4,0x7,0x2,0x5,0x5,0x3,0x9,0x2,0x0,0x4,0x4,
	0x4,0x4,0x4,0x4,0x2,0x0,0x0,0x2,0x4,0x4,0x4,0x4,
};

Checkbox::Checkbox(char *label)
{
	this->checked = false;
	this->label  = label;
	this->itemEvent.setType(Event::ITEM_SELECTED);
	this->itemEvent.setSource(this);
	this->group = NULL;
}

Checkbox::~Checkbox()
{
}

void Checkbox::setChecked(bool checked)
{
	if (this->checked == true && checked == false) {
		this->checked = false;
		repaint();
	} else if (this->checked == false && checked == true) {
		this->checked = true;
		// 選択イベント発生
		if (this->group != NULL) {
			this->group->onEvent(&this->itemEvent);
			getParent()->onEvent(&this->itemEvent);
		}
		repaint();
	}
}

void Checkbox::setLabel(char *label)
{
	this->label = label;
	repaint();
}

void Checkbox::onPaint(Graphics *g)
{
	int w = getWidth(), h = getHeight();
	
	// 一度背景色でクリア
	g->setColor(getBackground());
	g->fillRect(0, 0, w, h);
	
	// 文字
	int fh = getFontMetrics()->getHeight(getLabel());
	int y = (h - fh) / 2;
	if (getEnabled() == true) {
		g->setColor(getForeground());
	} else {
		g->setColor(Color::GRAY);
	}
	g->drawText(getLabel(), 14, y);
	
	// チェック
	for (int i = 0; i < 12; i++) {
		for (int j = 0; j < 12; j++) {
			// チェックの周りは背景色で塗る
			unsigned int c = 0;
			if (this->checked == true) {
				c = checked_palette[checked_data[i * 12 + j] & 0xFF];
			} else {
				c = unchecked_palette[unchecked_data[i * 12 + j] & 0xFF];
			}
			if (c == 0xffc0c0c0) {
				c = getBackground();
			}
			g->drawPixel(j + 0, i + y, c);
		}
	}

}

void Checkbox::onEvent(Event *event)
{
	// 非活性の時はイベントを受け付けない
	if (getEnabled() == false) return;

	if (event->getType() == MouseEvent::MOUSE_RELEASED) {
		if (this->checked == false || this->group == NULL) {
			setChecked(!this->checked);
		}
		getParent()->onEvent(event);
	}
}
